Index: /branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/experiment.view.js
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/experiment.view.js	(revision 9323)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/experiment.view.js	(revision 9324)
@@ -502,210 +540,334 @@
                 this.exhaust(index + 1, element);
             }
-        } else {
-            element[index] = {
-                Name: currentParameter.Name,
-                Value: currentParameter.Value
-            };
-            if (currentParameter.Options) {
-                element[index].Options = currentParameter.Options;
-            }
-            this.exhaust(index + 1, element);
-        }
-    }
-});
-
-var TableEditView = Backbone.View.extend({
-    events: {
-        'change': 'valueChanged',
-        'click button[data-operation="Add"]': 'addClicked',
-        'click button[data-operation="Remove"]': 'removeClicked'
+        }
+    });
+
+    my.TableEditView = Backbone.View.extend({
+        events: {
+            'change': 'valueChanged',
+            'click button[data-operation="Add"]': 'addClicked',
+            'click button[data-operation="Remove"]': 'removeClicked'
+        },
+        render: function () {
+            this.$el.empty();
+            // http: //stackoverflow.com/questions/8749236/create-table-with-jquery-append
+            var table = $('<table></table>').addClass('editableTable');
+
+            // determine dimensions
+            var rows = this.model.length;
+            var columns = 1;
+            if ($.isArray(this.model[0])) {
+                columns = this.model[0].length;
+            }
+
+            // create head elements
+            var head = $('<thead></thead>');
+            var headerRow = $('<tr></tr>');
+            headerRow.appendTo(head);
+            if (this.options.rowNames) {
+                var rowNames = this.options.rowNames;
+                for (var i = 0; i < rowNames.length; i++) {
+                    $('<td />').text(rowNames[i]).appendTo(headerRow);
+                }
+            } else {
+                for (var i = 0; i < columns; i++) {
+                    $('<td />').text((i + 1) + '. Column').appendTo(headerRow);
+                }
+            }
+            head.appendTo(table);
+
+            // create body
+            var body = $('<tbody></tbody>');
+
+            for (var i = 0; i < rows; i++) {
+                var row = $('<tr></tr>');
+                for (var j = 0; j < columns; j++) {
+                    var rowContent = this.model[i];
+                    var columnEntry = $.isArray(rowContent) ? rowContent[j] : rowContent;
+                    var col = $('<td></td>');
+                    if (this.options.editable) {
+                        $('<input type="text" name="' + i + '_' + j + '" />').val(columnEntry).appendTo(col);
+                    } else {
+                        col.text(columnEntry);
+                    }
+                    col.appendTo(row);
+                }
+                if (this.options.editable) {
+                    $('<button data-operation="Add" name="' + i + '" />').val(columnEntry).text('+').appendTo(col);
+                    $('<button data-operation="Remove" name="' + i + '" />').val(columnEntry).text('-').appendTo(col);
+                }
+                row.appendTo(body);
+            }
+            body.appendTo(table);
+
+            table.appendTo(this.$el);
+            if (this.options.useDatatable)
+                table.dataTable();
+        },
+        valueChanged: function (evt) {
+            var target = $(evt.target);
+            var value = target.val();
+            var index = target.attr('name');
+            var splittedName = index.split('_');
+            var i = parseInt(splittedName[0]);
+            var j = parseInt(splittedName[1]);
+            if ($.isArray(this.model[i])) {
+                this.model[i][j] = parseFloat(value);
+            } else {
+                this.model[i] = parseFloat(value);
+            }
+        },
+        addClicked: function (evt) {
+            var target = $(evt.target);
+            var index = target.attr('name');
+            var i = parseInt(index);
+            if ($.isArray(this.model[i])) {
+                var cpy = [];
+                for (var j = 0; j < this.model[i].length; j++) {
+                    cpy.push(this.model[i][j]);
+                }
+                this.model.splice(i, 0, cpy);
+            } else {
+                this.model.splice(i, 0, this.model[i]);
+            }
+            // render after model changes
+            this.render();
+        },
+        removeClicked: function (evt) {
+            var target = $(evt.target);
+            var index = target.attr('name');
+            var i = parseInt(index);
+            this.model.splice(i, 1);
+            // render after model changes
+            this.render();
+        }
+    });
+
+    my.NumberEditableView = Backbone.View.extend({
+        events: {
+            'change': 'valueChanged'
+        },
+        render: function () {
+            $('<input type="text" />').val(this.model.Value).appendTo(this.$el);
+
+        },
+        valueChanged: function (evt) {
+            var value = $(evt.target).val();
+            if (!isNaN(value)) {
+                value = parseFloat(value);
+                this.model.Value = value;
+            } else {
+                $('input', this.$el).val(this.model.Value);
+            }
+        }
+    });
+
+    my.SelectionView = Backbone.View.extend({
+        events: {
+            'change': 'checked'
+        },
+        render: function () {
+            this.$el.empty();
+            var s = $('<select />').attr('data-name', this.model.Name).appendTo(this.$el);
+            for (var i = 0; i < this.model.Options.length; i++) {
+                $('<option />', { value: this.model.Options[i], text: this.model.Options[i] }).appendTo(s);
+            }
+            s.val(this.model.Value);
+        },
+        checked: function (evt) {
+            var value = $(evt.target).val();
+            var name = $(evt.target).attr('data-name')
+            this.trigger('selected', { name: name, value: value });
+        }
+    });
+
+    my.OptionSelectionView = Backbone.View.extend({
+        events: {
+            'change': 'checked'
+        },
+        render: function () {
+            this.$el.empty();
+            if ($.isArray(this.model)) {
+                for (var i = 0; i < this.model.length; i++) {
+                    $(_.template($('#checkbox_template').html(), { checked: false, name: this.model[i], text: this.model[i], hideText: this.options.hideText })).appendTo(this.$el);
+                }
+            }
+            else {
+                $(_.template($('#checkbox_template').html(), { checked: this.model, name: this.model, text: this.model, hideText: this.options.hideText })).appendTo(this.$el);
+            }
+        },
+        checked: function (evt) {
+            var checked = $(evt.target).is(':checked');
+            var name = $(evt.target).attr('name')
+            this.trigger('changed', { name: name, checked: checked });
+        }
+    });
+
+
+    my.PlotView = Backbone.View.extend({
+        render: function () {
+            this.$el.empty();
+            var plotLabels = undefined;
+            if (this.model.RowNames) {
+                plotLabels = [];
+                for (var i = 0; i < this.model.RowNames.length; i++) {
+                    plotLabels.push({ label: this.model.RowNames[i] });
+                }
+            }
+
+            var values = this.model.Value ? this.model.Value : this.model;
+
+            var plotValues = [];
+            if ($.isArray(values[0])) {
+                var columnCount = values[0].length;
+                var colVals = {};
+                for (var i = 0; i < columnCount; i++)
+                    colVals[i] = [];
+
+                for (var i = 0; i < values.length; i++) {
+                    for (var j = 0; j < columnCount; j++) {
+                        colVals[j].push(values[i][j]);
+                    }
+                }
+
+                for (var i = 0; i < columnCount; i++) {
+                    plotValues.push(colVals[i]);
+                }
+            } else {
+                plotValues.push(values);
+            }
+
+            if (!this.$el.attr('id')) {
+                this.$el.attr('id', my.PlotView.nextId());
+            }
+
+            this.$el.css('width', '500px');
+
+            this.plot = $.jqplot(this.$el.attr('id'), plotValues, {
+                cursor: {
+                    show: true,
+                    zoom: true,
+                    showTooltip: false
+                },
+                series: plotLabels,
+                seriesDefaults: {
+                    lineWidth: 1.5,
+                    markerOptions: {
+                        size: 2,
+                        lineWidth: 2
+                    }
+                },
+                legend: {
+                    show: true,
+                    placement: 'outsideGrid'
+                },
+                highlighter: {
+                    show: true,
+                    sizeAdjust: 7.5
+                }
+            });
+        },
+        refresh: function () {
+            if (this.plot)
+                this.plot.replot({ resetAxes: true });
+        }
     },
-    render: function () {
-        this.$el.empty();
-        // http: //stackoverflow.com/questions/8749236/create-table-with-jquery-append
-        var table = $('<table></table>').addClass('editableTable');
-
-        // determine dimensions
-        var rows = this.model.length;
-        var columns = 1;
-        if ($.isArray(this.model[0])) {
-            columns = this.model[0].length;
-        }
-
-        // create head elements
-        var head = $('<thead></thead>');
-        var headerRow = $('<tr></tr>');
-        headerRow.appendTo(head);
-        for (var i = 0; i < columns; i++) {
-            $('<td />').text((i + 1) + '. Column').appendTo(headerRow);
-        }
-        head.appendTo(table);
-
-        // create body
-        var body = $('<tbody></tbody>');
-
-        for (var i = 0; i < rows; i++) {
-            var row = $('<tr></tr>');
-            for (var j = 0; j < columns; j++) {
-                var rowContent = this.model[i];
-                var columnEntry = $.isArray(rowContent) ? rowContent[j] : rowContent;
-                var col = $('<td></td>');
-                $('<input type="text" name="' + i + '_' + j + '" />').val(columnEntry).appendTo(col);
-                col.appendTo(row);
-            }
-            if (this.options.editable) {
-                $('<button data-operation="Add" name="' + i + '" />').val(columnEntry).text('+').appendTo(col);
-                $('<button data-operation="Remove" name="' + i + '" />').val(columnEntry).text('-').appendTo(col);
-            }
-            row.appendTo(body);
-        }
-        body.appendTo(table);
-        table.appendTo(this.$el);
-    },
-    valueChanged: function (evt) {
-        var target = $(evt.target);
-        var value = target.val();
-        var index = target.getattr('name');
-        var splittedName = index.split('_');
-        var i = parseInt(splittedName[0]);
-        var j = parseInt(splittedName[1]);
-        if ($.isArray(this.model[i])) {
-            this.model[i][j] = parseFloat(value);
-        } else {
-            this.model[i] = parseFloat(value);
-        }
-    },
-    addClicked: function (evt) {
-        var target = $(evt.target);
-        var index = target.attr('name');
-        var i = parseInt(index);
-        if ($.isArray(this.model[i])) {
-            var cpy = [];
-            for (var j = 0; j < this.model[i].length; j++) {
-                cpy.push(this.model[i][j]);
-            }
-            this.model.splice(i, 0, cpy);
-        } else {
-            this.model.splice(i, 0, this.model[i]);
-        }
-        // render after model changes
-        this.render();
-    },
-    removeClicked: function (evt) {
-        var target = $(evt.target);
-        var index = target.attr('name');
-        var i = parseInt(index);
-        this.model.splice(i, 1);
-        // render after model changes
-        this.render();
-    }
-});
-
-var OptionSelectionView = Backbone.View.extend({
-    events: {
-        'change': 'checked'
-    },
-    render: function () {
-        this.$el.empty();
-
-        for (var i = 0; i < this.model.length; i++) {
-            $(_.template($('#checkbox_template').html(), { name: this.model[i], text: this.model[i] })).appendTo(this.$el);
-        }
-    },
-    checked: function (evt) {
-        var checked = $(evt.target).is(':checked');
-        var name = $(evt.target).attr('name')
-        this.trigger('changed', { name: name, checked: checked });
-    }
-});
-
-var VariationContentView = Backbone.View.extend({
-    render: function () {
-        var self = this;
-        if (this.model.Value === 'false' || this.model.Value === 'true' ||
-            this.model.Value === true || this.model.Value === false) {
-            $(_.template($('#variation_boolean_template').html(), {})).appendTo(this.$el);
-            this.model.Generated = [false, true];
-        }
-        else if (!isNaN(this.model.Value)) {
-            var elem = $(_.template($('#variation_number_template').html(), {}));
-            elem.appendTo(this.$el)
-            $('input[name="generate"]', elem).click(function (evt) { self.openGenerator(evt); });
-            if (!this.model.Generated) {
-                this.model.Generated = [0, 1, 2];
-            }
-            var tev = new TableEditView({ model: this.model.Generated, el: $('div div', this.$el), editable: true });
+  {
+      plotId: 1,
+      nextId: function () {
+          return my.PlotView.plotId++;
+      }
+  });
+
+    my.VariationContentView = Backbone.View.extend({
+        render: function () {
+            var self = this;
+            if (this.model.Value === 'false' || this.model.Value === 'true' ||
+              this.model.Value === true || this.model.Value === false) {
+                $(_.template($('#variation_boolean_template').html(), {})).appendTo(this.$el);
+                this.model.Generated = [false, true];
+            }
+            else if (!isNaN(this.model.Value)) {
+                var elem = $(_.template($('#variation_number_template').html(), {}));
+                elem.appendTo(this.$el)
+                $('input[name="generate"]', elem).click(function (evt) { self.openGenerator(evt); });
+                if (!this.model.Generated) {
+                    this.model.Generated = [0, 1, 2];
+                }
+                var tev = new my.TableEditView({ model: this.model.Generated, el: $('div div', this.$el), editable: true });
+                tev.render();
+            }
+            else if (this.model.Options) {
+                var osv = new my.OptionSelectionView({ model: this.model.Options, el: this.$el });
+                this.listenTo(osv, 'changed', function (evt) {
+                    self.selectionChanged(evt);
+                });
+                if (!this.model.Generated)
+                    this.model.Generated = [];
+                osv.render();
+                for (var i = 0; i < this.model.Generated.length; i++) {
+                    $('input[name="' + this.model.Generated[i] + '"]', this.$el).attr('checked', 'checked');
+                }
+            }
+        },
+        openGenerator: function (evt) {
+            var self = this;
+            var generator = new my.GeneratorDialog();
+            this.listenTo(generator, 'success', function (data) {
+                self.doGenerate(data);
+            });
+            generator.render();
+        },
+        doGenerate: function (data) {
+            if (data.minimum > data.maximum) {
+                var tmp = data.minimum;
+                data.minimum = data.maximum;
+                data.maximum = tmp;
+            }
+            if (data.step < 0)
+                data.step *= -1;
+            if (data.step == 0)
+                data.step = 1;
+            this.model.Generated = _.range(data.minimum, data.maximum + 1, data.step);
+            var tev = new my.TableEditView({ model: this.model.Generated, el: $('div div', this.$el), editable: true });
             tev.render();
-        }
-        else if (this.model.Options) {
-            var osv = new OptionSelectionView({ model: this.model.Options, el: this.$el });
-            this.listenTo(osv, 'changed', function (evt) {
-                self.selectionChanged(evt);
-            });
-            if (!this.model.Generated)
-                this.model.Generated = [];
-            osv.render();
-            for (var i = 0; i < this.model.Generated.length; i++) {
-                $('input[name="' + this.model.Generated[i] + '"]', this.$el).attr('checked', 'checked');
-            }
-        }
-    },
-    openGenerator: function (evt) {
-        var self = this;
-        var generator = new GeneratorDialog();
-        this.listenTo(generator, 'success', function (data) {
-            self.doGenerate(data);
-        });
-        generator.render();
-    },
-    doGenerate: function (data) {
-        if (data.minimum > data.maximum) {
-            var tmp = data.minimum;
-            data.minimum = data.maximum;
-            data.maximum = tmp;
-        }
-        if (data.step < 0)
-            data.step *= -1;
-        if (data.step == 0)
-            data.step = 1;
-        this.model.Generated = _.range(data.minimum, data.maximum + 1, data.step);
-        var tev = new TableEditView({ model: this.model.Generated, el: $('div div', this.$el), editable: true });
-        tev.render();
-    },
-    selectionChanged: function (evt) {
-        if (!evt.checked) {
-            this.model.Generated = _.without(this.model.Generated, evt.name);
-        } else if (_.indexOf(this.model.Generated, evt.name) == -1) {
-            this.model.Generated.push(evt.name);
-        }
-    }
-});
-
-var GeneratorDialog = Backbone.View.extend({
-    render: function() {
-        var self = this;
-        var generator = $(_.template($('#variation_generator_template').html(),{}));
-        generator.dialog({
-            buttons: {
-                "Abort": function () {
-                    $(this).dialog("close");
-                },
-                "OK": function () {
-                    $(this).dialog("close");
-                    self.trigger("success", {
-                        minimum: parseInt($('input[name="minimum"]', generator).val()),
-                        maximum: parseInt($('input[name="maximum"]', generator).val()),
-                        step: parseFloat($('input[name="step"]', generator).val())
-                    });
-                }
-            }
-        });
-    }
-});
-
-var VariationEntryView = Backbone.View.extend({
-    render: function () {
-        var entryTemplate = _.template($('#variationentry_template').html(), this.model);
-        $(entryTemplate).appendTo(this.$el);        
-    }
-});
+        },
+        selectionChanged: function (evt) {
+            if (!evt.checked) {
+                this.model.Generated = _.without(this.model.Generated, evt.name);
+            } else if (_.indexOf(this.model.Generated, evt.name) == -1) {
+                this.model.Generated.push(evt.name);
+            }
+        }
+    });
+
+    my.GeneratorDialog = Backbone.View.extend({
+        render: function () {
+            var self = this;
+            var generator = $(_.template($('#variation_generator_template').html(), {}));
+            generator.dialog({
+                buttons: {
+                    "Abort": function () {
+                        $(this).dialog("close");
+                    },
+                    "OK": function () {
+                        $(this).dialog("close");
+                        self.trigger("success", {
+                            minimum: parseInt($('input[name="minimum"]', generator).val()),
+                            maximum: parseInt($('input[name="maximum"]', generator).val()),
+                            step: parseFloat($('input[name="step"]', generator).val())
+                        });
+                    }
+                }
+            });
+        }
+    });
+
+    my.VariationEntryView = Backbone.View.extend({
+        render: function () {
+            var entryTemplate = _.template($('#variationentry_template').html(), this.model);
+            $(entryTemplate).appendTo(this.$el);
+        }
+    });
+    return my;
+} (OAAS_VIEW || {}, Backbone, _, $, OAAS_MODEL));
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/general.view.js
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/general.view.js	(revision 9324)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/general.view.js	(revision 9324)
@@ -0,0 +1,4 @@
+﻿var OAAS_VIEW = (function (my, Backbone, _, $, OAAS_MODEL) {
+   
+    return my;
+} (OAAS_VIEW || {}, Backbone, _, $, OAAS_MODEL));
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/job.controller.js
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/job.controller.js	(revision 9324)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/job.controller.js	(revision 9324)
@@ -0,0 +1,36 @@
+﻿var OAAS_CONTROLLER = (function (my, Backbone, OAAS_VIEW, OAAS_MODEL, _, $) {
+    my.JobPageController = function () {
+        this.create = function () {
+            var self = this;
+            var jobList = new OAAS_MODEL.JobList();
+            var jobOverview = new OAAS_VIEW.JobOverView({ collection: jobList, el: $('#jobOverview') });
+
+            var listener = {};
+            // add listener capabilities to instance
+            _.extend(listener, Backbone.Events);
+
+            listener.listenTo(jobList, 'updated', function (evt) {
+                // refresh overview
+                jobOverview.render();
+            });
+
+            listener.listenTo(jobOverview, 'jobSelected', function (jobId) {
+                var runList = new OAAS_MODEL.RunList({ jobId: jobId });
+                var lv = new OAAS_VIEW.LoadingView({ el: $('#jobDetails'), model: 'Loading results of job...' });
+                lv.render();
+                runList.fetch({ cache: false, success: function () {
+                    $('#jobDetails').empty();
+                    var div = $('<div/>').appendTo($('#jobDetails'));
+                    var rv = new OAAS_VIEW.ResultView({ model: runList, el: div });
+                    rv.render();
+                    var av = new OAAS_VIEW.AccordionView({ el: div });
+                    av.render();
+                }
+                });
+            });
+
+            jobList.poll();
+        }
+    }
+    return my;
+} (OAAS_CONTROLLER || {}, Backbone, OAAS_VIEW, OAAS_MODEL, _, $));
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/job.model.js
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/job.model.js	(revision 9324)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Web/Content/job.model.js	(revision 9324)
@@ -0,0 +1,78 @@
+﻿// Adapting the module pattern to prevent namespace polution; it's related to the namespace pattern
+// http://www.adequatelygood.com/2010/3/JavaScript-Module-Pattern-In-Depth
+// http://stackoverflow.com/questions/881515/javascript-namespace-declaration#answer-3588712
+var OAAS_MODEL = (function (my, Backbone) {
+    // ================= MODEL ===================
+    my.Job = Backbone.Model.extend({
+        idAttribute: "Id",
+        defaults: {
+            Id: null,
+            Name: null,
+            Resource: null,
+            Group: null,
+            DateCreated: null,
+            State: 'Waiting',
+            Loading: true
+        },
+        url: function () {
+            return '/Job/Job?jobId=' + this.get('Id');
+        },
+        initialize: function (spec) {
+            // waiting or calculating
+            this.set({ Loading: spec.State == 0 || spec.State == 1 });
+        }
+    });
+
+    my.JobList = Backbone.Collection.extend({
+        url: function () {
+            return "/Job/JobList";
+        },
+        initialize: function (spec) {
+            this.listenTo(this, 'sync', this.adjustDate);
+        },
+        _poll: function () {
+            var self = this;
+            setTimeout(function () { self.poll() }, 5000);
+        },
+        poll: function () {
+            var self = this;
+            this.fetch({ cache: false, update: true, success: function () {
+                self._poll();
+            }
+            });
+        },
+        adjustDate: function () {
+            for (var i = 0; i < this.models.length; i++) {
+                // convert the MS date format here
+                var date = this.models[i].get('DateCreated');
+                // remove /Date(
+                if (!(date instanceof Date)) {
+                    var value = new Date(parseInt(date.substr(6)));
+                    this.models[i].set('DateCreated', value);
+                }
+            }
+            this.trigger('updated', this);
+        },
+        model: my.Job
+    });
+
+    my.Run = Backbone.Model.extend({
+        defaults: {
+            id: null,
+            name: null,
+            results: null
+        }
+    });
+
+    my.RunList = Backbone.Collection.extend({
+        initialize: function (spec) {
+            this.jobId = spec.jobId;
+        },
+        url: function () {
+            return "/Job/RunList?jobId=" + this.jobId;
+        },
+        model: my.Run
+    });
+
+    return my;
+} (OAAS_MODEL || {}, Backbone));
